#!/bin/sh

##################################################################
# Written by Spike^ekipS <spike@spikeekips.net>
##################################################################

dialog_prog=`which dialog`

if [ ! -x "${dialog_prog}" ];then
	echo ""
	echo "= ERROR ============================================="
	echo " dialog utility must be installed in your system."
	echo " Please install dialog, or set dialog in your PATH"
	echo "====================================================="
	echo ""
	echo ""
	exit
fi

VERSION="0.6"

Dialog="${dialog_prog} --begin 5 5"

ROOT=`pwd`
log_file="${ROOT}/mesian_install.log"

VERSION="0.6"

#---------------------------------------- message.
TITLE="Mesian ${VERSION}, Mesian is Web Mail!"

welcome_msg="\nWelcome to Mesian.\n\nWe will Un-Install the Mesian."
error_no_log_file="\nMesian was not installed.\nCheck your environment."
error_remove_mesian_root="\nMesian was not installed.\nCheck your environment."
error_no_sendmail="\n'sendmail' binary was not linked.\nRemove it manually."

success_job="\nMesian was successfully removed.\n"

goexit () {
	rm -f ./${tmp_file} &>/dev/null
	exit
}

#---------------------------------------- welcome message
${Dialog} \
	--backtitle "${TITLE}" \
	--ok-label "NEXT" \
	--msgbox "${welcome_msg}" 20 50

# check whether install information file exists or not.
if [ ! -r $log_file ];then
	${Dialog} \
		--backtitle "${TITLE}" \
		--ok-label "EXIT" \
		--msgbox "${error_no_log_file}" 20 50

	goexit
fi

# read log_file
source ${log_file}

# remove /var/mesian
if [ ! -d ${__MESIAN_ROOT__} ];then
	${Dialog} \
		--backtitle "${TITLE}" \
		--ok-label "EXIT" \
		--msgbox "${error_remove_mesian_root}" 20 50

	goexit
fi

rm -rf ${__MESIAN_ROOT__} &>/dev/null

if [ "$?" -ne "0" ];then
	${Dialog} \
		--backtitle "${TITLE}" \
		--ok-label "EXIT" \
		--msgbox "${error_remove_mesian_root}" 20 50

	goexit
fi

# remove sendmail link.
if [ ! -L "${directory_sendmail}/sendmail" ];then
	${Dialog} \
		--backtitle "${TITLE}" \
		--ok-label "EXIT" \
		--msgbox "${error_no_sendmail}" 20 50

	goexit
fi

if [ -n "${sendmail_org}" ];then
   rm -f ${directory_sendmail}/sendmail
   mv ${sendmail_org} ${directory_sendmail}/sendmail &>/dev/nullfi

${Dialog} \
	--backtitle "${TITLE}" \
	--ok-label "EXIT" \
	--msgbox "${success_job}" 20 50

exit 0

