# -*- coding: utf-8 -*-
import imaplib, string, re

PORT = imaplib.IMAP4_PORT

class Imap :

	Server = None
	message_num_list = []

	message_id = 1
	message_uid = None

	def __init__ (self) :
		pass

	def connect (self, **kwargs) :

		if not kwargs.has_key("port") :
			port = PORT
		else :
			try :
				port = int(kwargs["port"])
			except :
				port = PORT

		return self.__connect( \
			kwargs["host"], \
			port, \
			kwargs["user"], \
			kwargs["password"] \
		)

	def __connect (self, servername, port, username, password) :
		try :
			self.Server = imaplib.IMAP4(servername, port)
		except :
			retval = False
		else :
			retval = self.__login(username, password)

			if retval :
				self.Server.select()
				a, b = self.Server.search(None, 'ALL')
				self.num_of_message = len(b[0].split())

		return retval

	def __login (self, username, password) :

		try :
			self.Server.login(username, password)
		except :
			retval = False
		else :
			retval = True

		return retval

	def logout (self) :
		try :
			self.Server.close()
			self.Server.logout()
		except :
			pass

	def get_message_iduid (self) :
		typ, data = self.Server.search(None, "ALL")

		a = string.split(data[0])

		iduid_list = list()

		for i in a :
			typ, uid = self.Server.fetch(i, "UID")
			mo = re.match(".*\(UID (.*)\).*", uid[0])

			if mo != None :
				uid = mo.groups()[0]
			else :
				pass

			iduid_list.append((i, uid))

		return iduid_list

	def remove (self, uid) :

		self.Server.uid("store", uid, "FLAGS", "(\Deleted)")

		retval = self.Server.expunge()

		return retval

	def remove_all_message (self) :

		l = self.get_message_iduid()

		for id, uid in l :
			self.Server.uid("store", uid, "FLAGS", "(\Deleted)")

		self.Server.expunge()

	def fetch_all (self) :

		l = self.get_message_iduid()

		for id, uid in l :
			message.append(self.fetch(id))

		retval = message

		return retval

	def fetch (self, id) :

		a, data = self.Server.fetch(id, "(RFC822)")

		self.message_id += 1

		if data[0] == None :
			retval = False
		else :
			retval = data[0][1]

		return retval

"""
Description
-----------
Example
	M = imaplib.IMAP4()
	M.login(getpass.getuser(), getpass.getpass())
	M.select()
	typ, data = M.search(None, 'ALL')
	for num in data[0].split():
		 typ, data = M.fetch(num, '(RFC822)')
		 print 'Message %s\n%s\n' % (num, data[0][1])
	M.logout()

ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spike@spikeekips.net>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "Imap.py"

