# -*- coding: utf-8 -*-
import os, sre
import config, Log

class Virus :

	SCAN_CMD = "cat %s | %s --disable-summary --stdout -i --mbox -"
	FOUND = sre.compile(" FOUND\n$")

	def scan (self) :

		if os.path.exists(config.file["scanner"]) :
			self.__scan()

	def __scan (self) :

		# read file list in config.qmail["directory"]["message"]
		try :
			os.chdir(config.qmail["directory"]["message_tmp"])
		except OSError :
			msg_error = \
				"No such file or directory, %s" % config.qmail["directory"]["message_tmp"]

			L = Log.Log("scan_virus")
			L.info(msg_error)
			raise OSError, msg_error

		else :
			for i in os.listdir(".") : # read current directory.

				f_path = "%s/%s" % (config.qmail["directory"]["message_tmp"], i)

				if os.path.isdir(f_path) : continue
				if os.path.islink(f_path) : continue

				if os.path.isfile(f_path) :

					a = i.split("-")
					message_id = a[1]

					fi, fo, fe = \
							os.popen3(self.SCAN_CMD % (f_path, config.file["scanner"]), "t")

					if len(fe.readlines()) > 1 :
						continue
					else :
						virus_name = self.is_virus(fo)

						if not virus_name :
							self.save(i)
						else :
							# remove virus message.
							self.remove(f_path)

							# write log
							L = Log.Log("scan_virus")
							L.info( "%s : Virus, %s was found and remove it." % \
									(message_id, virus_name))

					# remove file.
					self.save(f_path)

	def remove (self, filename) :
		try :
			os.remove(filename)
		except :
			pass

		return True

	def save (self, filename) :

		try :
			os.rename( \
				"%s/%s" % (config.qmail["directory"]["message_tmp"], filename), \
				"%s/%s" % (config.qmail["directory"]["message"], filename), \
			)
		except :
			pass

		return True

	def is_virus (self, fo) :
		# check whether virus was found or not.
		a = fo.readlines()

		if len(a) < 1 : # not found
			retval = False
		else : # virus found

			virus_name = list()
			if self.FOUND.findall(a[0]) :
				try :
					virus_name = a[0].split(":")[1].replace("FOUND", "").strip()
				except :
					retval = False
				else :
					retval = virus_name
			else :
				retval = False

		return retval

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spike@spikeekips.net>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "Scan.py"

