# -*- coding: utf-8 -*-
import sql, myMySQLdb, myXML, message, time

class User :

	db = None
	user_list = []

	talbes = dict()
	uid = None

	def __init__ (self, db) :
		self.db = myMySQLdb.myMySQLdb(db)

		# make user id.
		self.uid = int(time.time())

	def get_all_user (self) :
		"""
		Get all user infomation,
			return value = (user id, user address)
		"""

		self.user_list = []

		self.db.query(sql.SQL_USER_INFO_ALL, True)

		for i in range(self.db.num_rows) :
			o = self.db.fetch()
			self.user_list.append( (o["id"], "%s@%s" % (o["name"], o["domain"])) )

		retval = self.user_list

		return retval

	def get_all_user_in_domain (self, domain) :
		"""
		@rtype : tuple(user id, user name, user domain)
		"""

		user_list = []

		self.db.query( \
			"select id, name, domain from user_priv where domain = '%s'" % domain, \
			True)

		for i in range(self.db.num_rows) :
			o = self.db.fetch()
			user_list.append( (int(o["id"]), o["name"], o["domain"]) )

		return user_list

	def get_info (self, address) :

		(name, domain) = message.parse_address(address)

		o = self.db.fetch_one( \
			"select * from user_priv where name = '%s' and domain = '%s'" % \
			(name, domain)
		)

		return o


	############################################################################
	"""
	Add new user,
		1. U = User()
		2. U.set_name("name", "domain.net")
		3. U.add("password", info)
	"""

	def set_name (self, name, domain) :
		self.name = name
		self.domain = domain

	def __register_priv (self, **info) :
		"""
			INSERT INTO user_priv
			(
				name, domain,
				password, password_plain,
				quota,
				valid, pageLimit, createdTime,
				id,
				block_address, filter, remote_server,
				timeout,
				message_size_limit, document_size_limit
			) VALUES (
				'%s','%s',
				sha('%s'),'%s',
				'%s',
				'1',10,'%s',
				'%s',
				'%s','%s','%s',
				'%s',
				'%s','%s'
			)
		"""

		try :
			__query = self.tables["system"]["reg_user"]
		except KeyError :
			retval = False
		else :
			try :
				query = __query % ( \
					myMySQLdb.escape_string(self.name),
					myMySQLdb.escape_string(self.domain),
					myMySQLdb.escape_string(info["password"]),
					myMySQLdb.escape_string(info["password"]),
					int(info["quota"]) * 1000000,
					time.time(),
					self.uid,
					info["block_address"],
					info["filter"],
					info["remote_server"],
					"1800",
					int(info["message_size_limit"]) * 1000000,
					int(info["document_size_limit"]) * 1000000
				)
			except KeyError :
				retval = False
			else :
				self.db.query(query)

				retval = self.db.retval

		return retval

	def __unregister_priv (self) :

		# get user no
		a = self.get_info("%s@%s" % (self.name, self.domain))

		try :
			no = int(a["no"])
			id = int(a["id"])
		except KeyError :
			retval = False
		else :
			self.userno = no
			self.userid = id

			try :
				__query = self.tables["system"]["unreg_user"]
				__query2 = self.tables["system"]["unreg_user_alias"]
			except KeyError :
				retval = False
			else :
				# remove user from user_priv
				self.db.query(__query % (self.name, self.domain))

				retval = self.db.retval

				# remove user from user_alias_priv
				if retval :
					self.db.query(__query2 % self.userno)
					retval = self.db.retval

		return retval

	def __create_tables (self) :

		if not (self.tables.has_key("user") and self.tables.has_key("user_value")) :
			retval = False
		else :
			retval = True

			# create tables.
			for (i, j) in self.tables["user"].items() :
				if not retval : break
				self.db.query(j % self.uid)

				retval = self.db.retval

			# insert user value.
			for (i, j) in self.tables["user_value"].items() :
				if not retval : break
				self.db.query(j % self.uid)

				retval = self.db.retval

		return retval

	def __remove_tables (self) :

		if not self.tables.has_key("user") :
			retval = False
		else :
			retval = True

			# create tables.
			for (i, j) in self.tables["user"].items() :
				self.db.query("drop table %s_%s" % (i, self.userid))

		return True

	def add (self, **info) :

		X = myXML.myXML()
		X.set_tables_xml()
		self.tables = X.get_table_scheme()

		# insert info into user_priv
		retval = self.__register_priv(**info)

		if retval : retval = self.__create_tables()

		return retval

	def remove (self) :

		X = myXML.myXML()
		X.set_tables_xml()
		self.tables = X.get_table_scheme()

		# remove user from user_priv & user_alias_priv.
		retval = self.__unregister_priv()

		if retval : retval = self.__remove_tables()

		return retval

__author__ =  "Spike^ekipS <spike@spikeekips.net>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "User.py"

