<?

include_once $global["root"] . "/lib/Domain.php";
include_once $global["root"] . "/lib/Globals.php";
include_once $global["root"] . "/lib/User.php";

class Authentication {

	var $authenticated = false;

	var $username;
	var $domain;

	function Authentication ($address=false) {
		if ($address) {
			$this->set_address($address);
		} else {
			$this->domain = $_SERVER["HTTP_HOST"];
		}
	}

	function set_address ($address) {
		$c = split("@", $address);
		$this->username = $c[0];
		$this->domain = $c[1];
	}

	function check () {

		if (! $_SESSION["user_authenticated"]) {
			$this->logout();
		}

		if ($_SESSION["config_timeout"] > 0) {
			$this->set_keepalive();
		}
	}

	function assign () {
		if (array_key_exists("config_timeout", $_SESSION)) {
			$_SESSION["config_timeout"] = 0;
		}
	}

	function escape ($method="_GET") {

		if (is_array(${$method}) and ${$method}) {
			$this->logout();
		}
	}

	function set_keepalive () {

		if (mktime() < $_SESSION["user_timeout"]) {
			$_SESSION["user_timeout"] = mktime() + $_SESSION["config_timeout"];
		} else {
			$this->logout();
		}
	}

	function logout () {

		$this->authenticated = false;

		session_destroy();
		@mysql_close();

		Header (sprintf("Location: http://%s/login.php", $_SERVER["HTTP_HOST"]));
		exit;
	}

	function verify ($password) {
		/*
		return value
			false	: unknown user
			true	: valid user
			2     : hold
			-2		: postmaster user
			-3		: global user
		*/

		$DB = new MySQLdb;

		$this->authenticated = false;

		$Domain = new Domain;

		if (! $Domain->get_valid($this->domain)) {
			$this->authenticated = false;
			$retval = false;
		} else {
			$User = new User;
			$var = $User->authenticate($this->username, $this->domain, $password);
			switch (true) {
				case (intval($var) === -1) : // hold
					$this->authenticated = false;
					$retval = 2;
				break;

				case ($var == true) : // valid
					$this->authenticated = true;
					$retval = true;
				break;

				default : // unknown
					$retval = false;
			}

			if (! $retval) {
				$Global = new Globals;
				$var = $Global->authenticate($this->username, $password);

				switch (true) {
					case ($var == true) : // valid
						$this->authenticated = true;
						$retval = -3;
					break;

					default : // unknown
						$retval = false;
				}

			}

		}

		return $retval;
	}

	function get_global_value () {

		$Globals = new Globals;
		$retval = $Globals->get_info();

		return $retval;
	}

	function get_domain_value () {

		$Domain = new Domain;
		$retval = $Domain->get_info($this->domain);

		return $retval;
	}

	function get_user_value () {

		$User = new User;
		$retval = $User->get_info_by_address($this->username, $this->domain);

		return $retval;
	}

	function remove () {

		while (list($i, $j) = each($_SESSION)) {
			if (! ereg("^config_", $i)) continue;
			unset($_SESSION[$i]);
		}
	}

}

/*
Description
-----------

Author
------
 Spike^ekipS <spike@spikeekips.net>

Changelog
---------

Usage
-----

*/

?>
