<?

include_once $global["root"] . "/lib/Directory.php";

class Quota {

	/*
	Quota Policy is,
		1. can not receive new message, but send message.
		2. no receiving and sending message.
		3. can receive new message up to surplus against domain's quota,
			 but can not send message.
		4. can receive/send message up to surplus against domain's quota.

	column in user_priv
		quota_policy
			. set(1, 2, 3, 4)
	*/

	var $current_total_size = 0;

	var $SQL_GET_USER_POLICY = "select quota_policy from user_priv where id = '%s'";
	var $SQL_UPDATE_USER_POLICY = "update from user_priv set quota_policy = '%s'
		where id = '%s'";

	var $value_of_quota_policy = array(1,2,3,4);

	var $quota = 0;
	var $domain_quota = 0;

	function Quota () {

		if ( array_key_exists("config_quota", $_SESSION) and
				array_key_exists("config_domain_quota", $_SESSION) ) {
			$this->quota = $_SESSION["config_quota"];
			$this->domain_quota = $_SESSION["config_domain_quota"];

			$this->quota_surplus = $this->domain_quota - $this->quota;
		}
	}

	//---------------------------------------- on "Quota Policy"
	function get_policy ($user_id) {

		$DB = new MySQLdb;
		$o = $DB->fetch_one(sprintf($this->SQL_GET_USER_POLICY, $user_id));

		if (! $o["quota_policy"]) {
			$retval = 1;
		} else {
			$retval = $o["quota_policy"];
		}

		return $retval;
	}

	function set_policy ($pol, $user_id) {

		if (! in_array(intval($pol), $this->value_of_quota_policy)) {
			$retval = false;
		} else {
			$DB = new MySQLdb;
			$DB->execute_query(sprintf($this->SQL_UPDATE_USER_POLICY, $user_id, $pol));

			$retval = $DB->retval;
		}

		return $retval;
	}

	//----------------------------------------
	function get_current_total_size () {
		$Directory = new myDirectory;
		$this->current_total_size = $Directory->get_total_size();

		return $this->current_total_size;
	}

	function is_over_quota () {

		if ($this->current_total_size < 1) $this->get_current_total_size();

		if ($_SESSION["config_quota"] < $this->current_total_size) {
			$retval = true;
		} else {
			$retval = false;
		}

		return $retval;
	}

	// check whether quota is over or not.
	function check_quota ($action) {
		global $string;

		if ($this->current_total_size < 1) $this->get_current_total_size();
		$pol = intval($this->get_policy($_SESSION["config_id"]));

		/*
			* "Quota Policy" is,
				1. can not receive new message, but send message.
				2. no receiving and sending message.
				3. can receive new message up to surplus against domain's quota,
					 but can not send message.
				4. can receive/send message up to surplus against domain's quota.

			* action is,
				send
				save
		*/
		$retval = false;

		if ($action == "send") {
			switch ($pol) {
				case (2) :
					if ($this->quota > $this->current_total_size) $retval = true;
				break;
				case (3) :
					if ($this->quota > $this->current_total_size) $retval = true;
				break;
				case (4) :
					if ($this->quota > $this->current_total_size) {
						$retval = true;
					} else if ($this->quota_surplus > 0) {
						$retval = true;
					}
				break;

				default : // 1
					$retval = true;
			}

			if (! $retval) $_SESSION["tmp"]["msg"]["content"] = $string["message143"];

		} else if ($action == "save") {
			switch ($pol) {
				case (2) :
					if ($this->quota > $this->current_total_size) $retval = true;
				break;
				case (3) :
					if ($this->quota > $this->current_total_size) {
						$retval = true;
					} else if ($this->quota_surplus > 0) {
						$retval = true;
					}
				break;
				case (4) :
					if ($this->quota > $this->current_total_size) {
						$retval = true;
					} else if ($this->quota_surplus > 0) {
						$retval = true;
					}
				break;

				default : // 1
					if ($this->quota > $this->current_total_size) $retval = true;

			}

			if (! $retval) $_SESSION["tmp"]["msg"]["content"] = $string["admin75"];
		}

		return $retval;
	}

}


/*
Description
-----------

Author
------
 Ekips, Bae <spike@spikeekips.net>

Changelog
---------

Usage
-----

*/

?>
