# -*- coding: utf-8 -*-
import Domain, sql, time, myMySQLdb

"""
Remove orphan message, which was delivered to "postmaster".
"""

class Orphan :

	def __init__ (self, DB) :

		self.DB = DB
		self.DM = Domain.Domain()
		self.DM.set_db(self.DB)

	def execute (self) :

		# get all names of domain.
		domain_list = self.DM.get_all_postmaster_list()

		if len(domain_list) < 1 :
			retval = False
		else :
			for id, name in domain_list :

				# get orphan message policy and duration time.
				(policy, duration_time) = self.DM.get_orphan_policy(name)

				# remove orphan message, which is expired.
				if policy == "1" : # after duration time, remove it.
					self.__remove_orphan_message(id, duration_time)
				else :
					pass

	def __remove_orphan_message (self, postmaster_id, duration_time) :
		"""
		duration_time is a day.
		"""

		try :
			duration_time = int(duration_time)
		except :
			pass
		else :
			DB = myMySQLdb.myMySQLdb(self.DB, True)

			duration_limit = int(time.time()) - (duration_time * (60 * 60 * 24))

			DB.query(sql.SQL_DELETE_ORPHAN_MESSAGE % \
				{"domain_id": postmaster_id, "duration_limit": duration_limit})

			DB.stop_transaction()

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spike@spikeekips.net>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "Orphan.py"


