<?

include_once $global["root"] . "/lib/Authentication.php";
include_once $global["root"] . "/lib/MySQLdb.php";
include_once $global["root"] . "/lib/Domain.php";
include_once $global["root"] . "/lib/Globals.php";
include_once $global["root"] . "/lib/Session.php";
include_once $global["root"] . "/lib/User.php";
include_once $global["root"] . "/lib/Item.php";
include_once $global["root"] . "/lib/State.php";
include_once $global["root"] . "/lib/Template.php";

class Authentication_User extends Authentication {

	var $authenticated = false;

	var $skip_list_in_user_values = array(
			"password" => true,
			"password_plain" => true
		);


	function Authentication_User ($address="") {

		if ($address) $this->set_address($address);
	}

	function logout () {
		$this->authenticated = false;

		session_destroy();

		@mysql_close();

		Header (sprintf("Location: http://%s/login.php", $_SERVER["HTTP_HOST"]));
		exit;
	}

	function assign () {
		global $global;

		$var_global = $this->get_global_value();
		$var_domain = $this->get_domain_value();
		$var_user = $this->get_user_value();

		$this->remove();

		// assign user value to $_SESSION.
		while (list($i, $j) = each($var_user)) {

			if (ereg("^[0-9][0-9]*$", $i)) continue;
			if (array_key_exists($i, $this->skip_list_in_user_values)) continue;

			$_SESSION[sprintf("config_%s", $i)] = $j;
		}

		$_SESSION["config_domain_id"] = $var_domain["id"];
		$_SESSION["config_www_name"] = $var_domain["www_name"];

		///////////////////////////////////////////////////////////////////
		// check current value.

		// quota
		if ($var_user["quota"] > $var_domain["quota"]) {
			$_SESSION["config_quota"] = $var_domain["quota"];
		} else {
			$_SESSION["config_quota"] = $var_user["quota"];
		}
		$_SESSION["config_domain_quota"] = $var_domain["quota"];

		// message size limit
		if ($var_user["message_size_limit"] >
				$var_domain["message_size_limit"]) {
			$_SESSION["config_message_size_limit"] =
				$var_domain["message_size_limit"];
		} else {
			$_SESSION["config_message_size_limit"] =
				$var_user["message_size_limit"];
		}

		// document size limit
		if ($var_user["document_size_limit"] >
				$var_domain["document_size_limit"]) {
			$_SESSION["config_document_size_limit"] =
				$var_domain["document_size_limit"];
		} else {
			$_SESSION["config_document_size_limit"] =
				$var_user["document_size_limit"];
		}

		///////////////////////////////////////////////////////////////////

		// user's email address
		$_SESSION["config_address"] =
			$_SESSION["config_name"] . "@" . $_SESSION["config_domain"];

		// language
		if (! $_SESSION["config_lang"]) {
			$_SESSION["config_lang"] = $global["default_language"];
		}

		// set timeout.
		$_SESSION["user_timeout"] = $_SESSION["config_timeout"] + mktime();

		// etc
		$item = new Item();
		$item->set_item_type();

		$State = new State;
		$State->assign_saved_sort();

		// set theme directory.
		$Template = new Template;
		$Template->set_theme($var_user["theme"]);

		$_SESSION["user_authenticated"] = true;

		// set postmaster id
		$User = new User;
		$_SESSION["config_postmaster_id"] =
			$User->get_postmaster_id($_SESSION["config_domain"]);

		$is_postmaster = $User->is_postmaster();
		$_SESSION["user_is_postmaster"] = $is_postmaster;

		if ($is_postmaster) {
			$_SESSION["user_type"] = "postmaster";
		} else {
			$_SESSION["user_type"] = "user";
		}

		// assign postmaster value.
		if ($is_postmaster) {
			$_SESSION["config_user_limit"] = $var_domain["user_limit"]; // user limit
		}

		$_SESSION["user_global_url"] = sprintf("http://%s", $_SERVER["HTTP_HOST"]);
		$_SESSION["user_theme_url"] =
			sprintf("http://%s/template/%s", $_SERVER["HTTP_HOST"], $_SESSION["config_theme"]);

		$Template = new Template;
		$Template->set_theme();

	}

}

/*
Description
-----------

Author
------
 Spike^ekipS <spike@spikeekips.net>

Changelog
---------

Usage
-----

*/

?>
