<?

include_once $global["root"] . "/lib/XML.php";

class User {

	var $info;

	// sql
	var $SQL_GET_USER_INFO = "select SQL_CACHE * from user_priv where no = '%s'";
	var $SQL_GET_USER_INFO1 = "select SQL_CACHE * from user_priv where id = '%s'";
	var $SQL_GET_USER_INFO2 =
		"select SQL_CACHE * from user_priv where name = '%s' and domain = '%s'";
	var $SQL_GET_POSTMASTER_ID =
		"select SQL_CACHE id from user_priv where name = '%s' and domain = '%s'";

	var $SQL_REMOVE_USER_ALIAS = "delete from user_alias_priv where no = '%s'";
	var $SQL_REMOVE_USER_IN_USER_PRIV = "delete from user_priv where no = '%s'";

	var $SQL_SET_VALID_ALIAS = "update user_alias_priv set valid = '1' where no = '%s'";
	var $SQL_SET_NOT_VALID_ALIAS = "update user_alias_priv set valid = '0' where no = '%s'";
	var $SQL_SET_VALID = "update user_priv set valid = '1' where no = '%s'";
	var $SQL_SET_NOT_VALID = "update user_priv set valid = '0' where no = '%s'";

	var $SQL_COUNT_USER = "select SQL_CACHE count(no) as num from user_priv
			where name = '%s' and domain = '%s'";
	var $SQL_COUNT_USER_ALIAS = "select SQL_CACHE count(no) as num from user_alias_priv
			where name = '%s' and domain = '%s'";

	var $SQL_GET_USERS_IN_DOMAIN = "select SQL_CACHE count(no) as num from user_priv
			where domain = '%s'";
	var $SQL_GET_USER_ALIASES_IN_DOMAIN = "select SQL_CACHE
		count(no) as num from user_alias_priv where domain = '%s'";

	var $SQL_FIND_USER =
			"select SQL_CACHE password, valid from user_priv
				where name = '%s' and domain = '%s'";

	function User ($no=false, $id=false) {
		if ($no and ! $id) $this->get_info_by_no($no);
		if (! $no and $id) $this->get_info_by_id($id);
	}

	function authenticate ($username, $domain, $password) {
		/*
		retval is,
			true  : valid user
			false : unknown user
			-1    : it's hold
		*/

		$a = $this->get_info_by_address($username, $domain);

		//-------------------------------------------------- pre-handling
		if (strcmp(sha1($password), $a["password"]) !== 0) {
			$retval = false;
		} else {

			if ($a["valid"] === strval("1")) {
				$retval = true;
			} else {
				$retval = -1;
			}
		}

		return $retval;
	}

	function is_postmaster () {
		if ($_SESSION["config_id"] == $_SESSION["config_postmaster_id"]) {
			$retval = true;
		} else {
			$retval = false;
		}

		return $retval;
	}

	//--------------------------------------------------
	function get_postmaster_id ($domain_name) {
		global $global;

		$DB = new MySQLdb;

		$o = $DB->fetch_one(sprintf($this->SQL_GET_POSTMASTER_ID,
			$global["postmaster"], $domain_name));

		if (! array_key_exists("id", $o)) {
			$retval = False;
		} else {
			$retval = $o["id"];
		}

		return $retval;
	}

	function get_info_by_address ($username, $domain_name) {

		$DB = new MySQLdb;

		$retval = $DB->fetch_one(sprintf($this->SQL_GET_USER_INFO2,
			$username, $domain_name));

		return $retval;

	}

	function get_info_by_no ($no) {
		$DB = new MySQLdb;
		$this->info = $DB->fetch_one(sprintf($this->SQL_GET_USER_INFO, $no));

		return $this->info;
	}

	function get_info_by_id ($id) {
		$DB = new MySQLdb;
		$this->info = $DB->fetch_one(sprintf($this->SQL_GET_USER_INFO1, $id));

		return $this->info;
	}

	function is_valid_name ($name) {

		if (eregi("^[a-z0-9-][a-z0-9_-]+[a-z0-9]$", $name)) {
			$retval = true;
		} else {
			$retval = false;
		}

		return $retval;
	}

	function is_duplicated ($username, $domain) {

		$DB = new MySQLdb;

		// check in user_alias_priv
		$o = $DB->fetch_one(sprintf($this->SQL_COUNT_USER_ALIAS, $username, $domain));

		if ($o["num"] > 0) {
			$retval = true;
		} else {
			// check in user_priv
			$o = $DB->fetch_one(sprintf($this->SQL_COUNT_USER, $username, $domain));

			if ($o["num"] > 0) {
				$retval = true;
			} else {
				$retval = false;
			}
		}

		return $retval;
	}

	function get_total_user_numbers_in_domain ($domain) {
		$DB = new MySQLdb;

		$total_num = 0;

		$o = $DB->fetch_one(sprintf($this->SQL_GET_USER_ALIASES_IN_DOMAIN, $domain));

		if ($o["num"] > 0) $total_num += $o["num"];

		$o = $DB->fetch_one(sprintf($this->SQL_GET_USERS_IN_DOMAIN, $domain));

		if ($o["num"] > 0) $total_num += $o["num"];

		return $total_num;
	}

	function set_not_valid_alias ($no) {

		$DB = new MySQLdb;

		$DB->query(sprintf($this->SQL_SET_NOT_VALID_ALIAS, $no));

		$retval = $DB->retval;

		return $retval;
	}

	function set_valid_alias ($no) {

		$DB = new MySQLdb;

		$DB->query(sprintf($this->SQL_SET_VALID_ALIAS, $no));

		$retval = $DB->retval;

		return $retval;
	}

	function set_not_valid ($no) {

		$DB = new MySQLdb;

		$DB->query(sprintf($this->SQL_SET_NOT_VALID, $no));

		$retval = $DB->retval;

		return $retval;
	}

	function set_valid ($no) {

		$DB = new MySQLdb;

		$DB->query(sprintf($this->SQL_SET_VALID, $no));

		$retval = $DB->retval;

		return $retval;
	}

	function add ($name, $domain, $password) {
		/*
		return value
			-3 : is not valid user name.
			-2 : user is already exists.
		*/

		$name = trim($name);
		$domain = trim($domain);
		$password = trim($password);

		if ($this->get_total_user_numbers_in_domain($domain) >=
				$_SESSION["config_user_limit"]) {

			$retval = "-4";
		} else {
			if ($this->is_duplicated($name, $domain)) {
				$retval = -2;
			} else if (! $this->is_valid_name($name)) {
				$retval = -3;
			} else {

				$id = $this->register_user_priv($name, $domain, $password);

				if (! $id) {
					$retval = false;
				} else {
					$retval = $this->create_table($id);
				}
			}
		}

		return $retval;
	}

	function add_alias ($name, $domain, $user_no) {
		/*
		return value
			-3 : is not valid user name.
			-2 : user is already exists.
		*/

		$name = trim($name);
		$domain = trim($domain);

		if ($this->get_total_user_numbers_in_domain($domain) >=
				$_SESSION["config_user_limit"]) {

			$retval = "-4";
		} else {
			if ($this->is_duplicated($name, $domain)) {
				$retval = -2;
			} else if (! $this->is_valid_name($name)) {
				$retval = -3;
			} else {
				$retval = $this->register_user_alias_priv($name, $domain, $user_no);
			}
		}

		return $retval;
	}

	function register_user_alias_priv ($name, $domain, $user_no) {

		$DB = new MySQLdb;

		$__tables = $this->get_table_scheme("system");

		$DB->query(
			sprintf($__tables["reg_user_alias"],
					$name,		// name
					$domain,		// domain
					$user_no	// user_no
				)
			);

		if ($DB->retval) {
			$retval = true;
		} else {
			$retval = false;
		}

		return $retval;
	}

	function register_user_priv ($name, $domain, $password) {

		$id = mktime(); // create user id.

		$__tables = $this->get_table_scheme("system");

		$DB = new MySQLdb;

		$DB->query(
			sprintf($__tables["reg_user"],
																					// no
					$name,														// name
					$domain,														// domain
					$password,													// password
					$password,													// password_plain
					$_SESSION["config_quota"],								// quota
																					// valid
																					// lang
																					// pageLimit
					$id,															// createdTime
					$id,															// id
																					// sort_method
																					// save_sort
																					// full_name
																					// reply_to
																					// signature
					$_SESSION["config_block_address"],					// block_address
					$_SESSION["config_filter"],							// filter
					$_SESSION["config_remote_server"],					// remote server
					$_SESSION["config_timeout"],							// timeout
																					// escape_filter_domain
					$_SESSION["config_message_size_limit"],			// message_size_limit
					$_SESSION["config_document_size_limit"]			// document_size_limit
				)
			);

		if ($DB->retval) {
			$retval = $id;
		} else {
			$retval = false;
		}

		return $retval;
	}

	function get_table_scheme ($key="user") {
		global $global;

		$xml = new XML;
		$table_data_file = sprintf("%s/etc/tables.xml", $global["mesian_root"]);
		$var = $xml->parse_xml_file_to_array($table_data_file);

		$a = $var["param"]["value"]["struct"]["member"];

		while (list($i, $j) = each($a)) {
			if ($j["name"] == $key) $retval = $j;
		}

		$ret = $retval["value"]["struct"]["member"];

		if (array_key_exists("name", $ret)) {
			$retval = array($ret["name"] => $ret["value"]["string"]);
		} else {
			$retval = array();
			while (list($i, $j) = each($ret)) {
				$retval[$j["name"]] = ereg_replace("[\n\t][\n\t]*", " ", $j["value"]["string"]);
			}
		}

		return $retval;
	}

	function create_table ($id) {
		global $global;

		$DB = new MySQLdb;

		// create table
		$__tables = $this->get_table_scheme("user");
		while (list($i, $j) = each($__tables)) $DB->query(sprintf($j, $id));

		// insert value.
		$__tables = $this->get_table_scheme("user_value");
		while (list($i, $j) = each($__tables)) $DB->query(sprintf($j, $id));

		$retval = $DB->retval;

		return $retval;
	}

	function remove_alias ($no) {

		$DB = new MySQLdb;

		$DB->execute_query(sprintf($this->SQL_REMOVE_USER_ALIAS, $no));

		$retval = $DB->retval;
		return $retval;
	}

	function remove_in_user_priv ($no) {

		$DB = new MySQLdb;

		$DB->execute_query(sprintf($this->SQL_REMOVE_USER_IN_USER_PRIV, $no));

		$retval = $DB->retval;

		return $retval;
	}

	function remove_user_table ($id) {

		$DB = new MySQLdb;

		$__tables = $this->get_table_scheme("user");
		while (list($i, $j) = each($__tables)) {
			$DB->execute_query(sprintf("drop table %s_%s", $i, $id));
		}

		//$retval = $DB->retval;
		$retval = true;

		return $retval;
	}

	function remove ($no, $id="") {

		if (! $id) {
			$this->get_info_by_no($no);
			$id = $this->info["id"];
		}

		// remove user in user_priv.
		$retval = $this->remove_in_user_priv($no);

		// remove user's table.
		if ($retval) {
			$retval = $this->remove_user_table($id);
		}

		return $retval;
	}

	/* name, domain, user_no, valid, is_fake */

	var $SQL_GET_FAKE_ADDRESS_OF_USER = "select name from user_alias_priv where user_no = '%s' and is_fake = '1'";
	function get_fake () {
		$DB = new MySQLdb;

		$query = sprintf($this->SQL_GET_FAKE_ADDRESS_OF_USER, $_SESSION["config_no"]);
		$DB->query($query, True);

		$fake_address = array();
		for ($i = 0; $i < $DB->num_rows; $i++) {
			$o = $DB->fetch();
			$fake_address[] = $o["name"];
		}

		return $fake_address;
	}
}

/*
Description
-----------

Author
------
 Spike^ekipS <spike@spikeekips.net>

Changelog
---------

Usage
-----

*/

?>
