# -*- coding: utf-8 -*-
import sys, os

MIN_VERION_PYTHON = (2,3,0)
MIN_VERION_APACHE = (1,3)
MIN_VERION_MYSQL = (4,0)
MIN_VERION_PHP = (4,3)

DIRECTORY_MESIAN = \
	("domains","engine", "www-data", "message")
FILE_MESIAN = \
	("sbin/mesian_engine.init", "sbin/mesian.init", "domains/.qmail-default")

def check_version_python () :

	if sys.version_info[:3] >= MIN_VERION_PYTHON :
		retval = True
	else :
		retval = False

	return retval

def check_version_apache (path) :

	try :
		fi, fo, fe = os.popen3("%s/bin/apachectl -v" % path)
	except :
		retval = False
	else :
		a = fo.readlines()
		if len(a) < 1 :
			retval = False
		else :
			version = tuple([func_version(x) for x in a[0].strip().split("/")[1].split(".")])

			if version >= MIN_VERION_APACHE :
				retval = True
			else :
				retval = False

	return retval

def check_version_mysql (path) :

	try :
		fi, fo, fe = os.popen3("%s/mysql -V" % path)
	except :
		retval = False
	else :
		a = fo.readlines()
		if len(a) < 1 :
			retval = False
		else :
			version = \
				tuple([func_version(x) \
					for x in \
					a[0].split("Ver")[1].split("Distrib")[1].split(",")[0].strip().split(".")])

			if version >= MIN_VERION_MYSQL :
				retval = True
			else :
				retval = False

	return retval

def check_version_php (path) :

	try :
		fi, fo, fe = os.popen3("%s/bin/php-config --version" % path)
	except :
		retval = False
	else :
		a = fo.readlines()
		if len(a) < 1 :
			retval = False
		else :
			version = \
				tuple([func_version(x) \
					for x in \
					a[0].split(".")])

			if version >= MIN_VERION_PHP :
				retval = True
			else :
				retval = False

	return retval

def check_is_qmail (path) :

	if os.path.exists("%s/qmail-inject" % path) :
		retval = True
	else :
		retval = False

	return retval

def check_is_mesian (path) :

	retval = True

	for i in DIRECTORY_MESIAN :
		if not retval : break

		if not os.path.exists("%s/%s" % (path, i)) :
			retval = False

	for i in FILE_MESIAN :
		if not retval : break

		if not os.path.exists("%s/%s" % (path, i)) :
			retval = False

	return retval

def func_version (x) :

	try :
		ver = int(x)
	except :
		ver = x

	return ver

USAGE = \
"""
Mesian 0.5 : %(prog_name)s,

Usage : %(prog_name)s name [name's root directory]
 ex) python %(prog_name)s apache /usr/local/lib/apache-2.0.45

   Supported name list is,
      python
      apache
      mysql
      php
      qmail
      mesian

------------------------------------------------
Bug reports: http://mesian-devel.spikeekips.net
"""

if __name__ == "__main__" :

	usage = {}
	usage["prog_name"] = sys.argv[0]

	action = False
	path = False

	if len(sys.argv) > 1 : action = sys.argv[1]
	if len(sys.argv) > 2 : path = sys.argv[2]

	if action == "python" :
		if check_version_python() :
			sys.exit(0)
		else :
			sys.exit(1)

	elif action == "apache" and path :
		if check_version_apache(path) :
			sys.exit(0)
		else :
			sys.exit(1)

	elif action == "mysql" and path :
		if check_version_mysql(path) :
			sys.exit(0)
		else :
			sys.exit(1)

	elif action == "php" and path :
		if check_version_php(path) :
			sys.exit(0)
		else :
			sys.exit(1)

	elif action == "qmail" and path :
		if check_version_qmail(path) :
			sys.exit(0)
		else :
			sys.exit(1)

	elif action == "mesian" and path :
		if check_version_mesian(path) :
			sys.exit(0)
		else :
			sys.exit(1)

	else :
		print USAGE % usage
		sys.exit(1)

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spike@spikeekips.net>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "Env.py"


