import sha, os, sys, time
try :
	import config
except :
	pass

import message, sql, myMySQLdb, Privilege, User, myXML

class Domain :

	domain_list = []

	rcpthosts_list = {}
	virtualdomains_list = {}
	assign_list = {}

	QMAIL_DEFAULT = "| %s $EXT@$HOST"

	QMAILD_UID = None
	QMAIL_GID = None

	#ASSIGN_ONE = "+%s-:%s:%s:%s:%s/%s:-::"
	ASSIGN_ONE = "+%s-:%s:%s:%s:%s:-::"

	action = {}
	action["add"] = "remove"
	action["remove"] = "add"

 	def __init__ (self) :
 		""" """
		pass

	def set_db (self, db) :
		self.DB = db

	#-------------------------------------------------- domain method
	def get_info (self, name) :

		DB = myMySQLdb.myMySQLdb(self.DB)
		o = DB.fetch_one(sql.SQL_DOMAIN_INFO % name)

		if DB.num_rows < 1 :
			retval = dict()
		else :
			retval = o

		return retval

	def get_all_postmaster_list (self) :
		"""
		@rtype : tuple(str, str), ...
					tuple(postmaster_id, domain name), ...
		"""
		
		DB = myMySQLdb.myMySQLdb(self.DB)
		o = DB.query_all(sql.SQL_POSTMASTER_INFO_ALL)

		if len(o) < 1 :
			retval = tuple()
		else :
			retval = o

		return retval

	def get_orphan_policy (self, name) :
		"""
		@rtype : dict(string type, int type)
					dict(orphan_policy, orphan_duration_time)
		"""

		o = self.get_info(name)

		if len(o) < 1 :
			orphan_policy = None
			orphan_duration_time = None
		else :
			orphan_policy = o["orphan_message_policy"]
			orphan_duration_time = int(o["orphan_message_duration_time"])

		return (orphan_policy, orphan_duration_time)

	def is_alias (self, name) :
		"""
		retval is real domain name.
		"""

		DB = myMySQLdb.myMySQLdb(self.DB)
		DB.query(sql.SQL_CHECK_DOMAIN_ALIAS % name, True)

		if DB.num_rows < 1 :
			retval = None
		else :
			a = DB.fetch()

			if a["valid"] == "0" :
				retval = None
			else :
				retval = self.get_name_by_id(a["domain_id"])

		DB.close()

		return retval

	def get_name_by_id (self, id) :

		DB = myMySQLdb.myMySQLdb(self.DB)
		DB.query(sql.SQL_GET_DOMAIN_NAME_BY_ID % id, True)

		if DB.num_rows < 1 :
			retval = None
		else :
			a = DB.fetch()

			if a["valid"] == "0" :
				retval = None
			else :
				retval = a["name"]

		DB.close()

		return retval

	#-------------------------------------------------- check file permission.
	def __check_file_permission (self, f) :

		MSG = \
"""Can not make "%s".
Please check it's permissions.

"""
		if os.path.exists(f) :
			try :
				f = open(f, "a")
			except IOError :
				sys.stderr.write(MSG % f)
				sys.exit(1)
			else :
				f.close()
				retval = True
		else :
			try :
				f = open(f, "w")
			except IOError :
				sys.stderr.write(MSG % f)
				sys.exit(1)
			else :
				f.close()
				retval = True

		return retval

	#-------------------------------------------------- make a domain list.
	def __get_domain_list (self) :
		try :
			f = open(config.qmail["file"]["virtualdomains"], "r")
		except :
			self.domain_list = []
		else :
			a = f.readlines()

			for i in a :
				b = i.split(":")
				self.domain_list.append(b[0].strip())

	def __check_domain_in_list (self, domain) :

		if domain in self.domain_list :
			retval = True
		else :
			retval = False

		return retval

	#--------------------------------------------------
	def __remove_domain_directory(self, domain) :
		""" """
		try :
			os.rmdir("%s/%s" % (config.qmail["directory"]["domains"], domain))
		except :
			retval = False
		else :
			retval = True

		return retval

	def __make_domain_directory(self, domain) :
		""" """

		try :
			os.mkdir("%s/%s" % (config.qmail["directory"]["domains"], domain))
		except :
			retval = False
		else :
			retval = True

		return retval

	def __domain_directory (self, action, domain) :

		if action == "add" :
			if self.__make_domain_directory(domain) :
				retval = self.__qmail_default("add", domain)

			else :
				retval = False
		elif action == "remove" :
			if self.__qmail_default("remove", domain) :
				retval = self.__remove_domain_directory(domain)
			else :
				retval = False
		else :
			retval = False

		return retval

	#--------------------------------------------------
	def __get_virtualdomains (self) :

		self.__check_file_permission(config.qmail["file"]["virtualdomains"])

		# make a virtualdomains list.
		try :
			f = open(config.qmail["file"]["virtualdomains"], "r")
		except :
			self.virtualdomains_list = {}
		else :
			a = f.readlines()
			f.close()

			for i in a :
				self.virtualdomains_list.update({i.strip().split(":")[0] : True})

	def __virtualdomains (self, action, domain) :
		"""
		retval
			-2 : domain is alread exists.
			-3 : domain name is not valid
			False : action failed
			True : action success.
		"""

		# check whether domain name is valid or not.
		self.__get_virtualdomains()

		if action == "add" :
			if domain in self.virtualdomains_list.keys() :
				retval = -2
			else :
				try :
					f = open(config.qmail["file"]["virtualdomains"], "a")
				except :
					retval = False
				else :
					f.write("%s:%s\n" % (domain, domain))
					f.close()

					retval = True

		elif action == "remove" :
			if not domain in self.virtualdomains_list.keys() :
				retval = -2
			else :
				cur_list = self.virtualdomains_list
				del(cur_list[domain])

				try :
					f = open(config.qmail["file"]["virtualdomains"], "w")
				except :
					retval = False
				else :
					a = []
					if len(cur_list) < 1 :
						pass
					else :
						for i in cur_list.keys() :
							a.append("%s:%s" % (i, i))

						f.write("%s\n" % "\n".join(a))

					f.close()

					retval = True
		else :
			retval = False

		if retval : self.__get_virtualdomains()

		return retval

	#--------------------------------------------------
	def __get_rcpthosts (self) :

		self.__check_file_permission(config.qmail["file"]["rcpthosts"])

		# make a rcpthosts list.
		try :
			f = open(config.qmail["file"]["rcpthosts"], "r")
		except :
			self.rcpthosts_list = {}
		else :
			a = f.readlines()
			f.close()

			for i in a : self.rcpthosts_list.update({i.strip() : True})

	def __update_rcpthosts (self) :
		a = os.system(config.qmail["file"]["qmail-newmrh"])

		if a == 0 :
			retval = True
		else :
			retval = False

		return retval

	def __rcpthosts (self, action, domain) :
		"""
		retval
			-2 : domain is alread exists.
			-3 : domain name is not valid
			False : action failed
			True : action success.
		"""

		# check whether domain name is valid or not.
		self.__get_rcpthosts()

		if action == "add" :
			if domain in self.rcpthosts_list.keys() :
				retval = -2
			else :
				try :
					f = open(config.qmail["file"]["rcpthosts"], "a")
				except :
					retval = False
				else :
					retval = True

				if retval :
					f.write("%s\n" % domain)
					f.close()

		elif action == "remove" :
			if not domain in self.rcpthosts_list.keys() :
				retval = -2
			else :
				cur_list = self.rcpthosts_list
				del(cur_list[domain])

				try :
					f = open(config.qmail["file"]["rcpthosts"], "w")
				except :
					retval = False
				else :
					if len(cur_list) < 1 :
						pass
					else :
						f.write("%s\n" % "\n".join(cur_list.keys()))

					f.close()

					retval = True
		else :
			retval = False

		if retval :
			self.__update_rcpthosts()
			self.__get_rcpthosts()

		return retval

	#--------------------------------------------------
	def __get_assign (self) :

		self.__check_file_permission(config.qmail["file"]["assign"])

		try :
			f = open(config.qmail["file"]["assign"], "r")
		except :
			self.assign_list = {}
		else :
			a = f.readlines()
			f.close()

			for i in a :
				if i.strip() == "." : continue

				try :
					k = i.strip().split(":")[1]
				except IndexError :
					continue
				else :
					self.assign_list.update({ k : i.strip()})

	def __assign (self, action, domain) :

		# check whether domain name is valid or not.
		self.__get_assign()

		if action == "add" :
			if domain in self.assign_list.keys() :
				retval = -2
			else :
				try :
					f = open(config.qmail["file"]["assign"], "w")
				except :
					retval = False
				else :

					self.QMAILD_UID = os.popen("id -u qmaild").read().strip()
					self.QMAIL_GID = os.popen("id -g qmaild").read().strip()

					if len(self.assign_list) < 1 :
						prev_assign_list = ""
					else :
						prev_assign_list = "\n".join(self.assign_list.values()) + "\n"

					f.write("%s%s\n." % (prev_assign_list, \
						self.ASSIGN_ONE % \
						(domain, domain, self.QMAILD_UID, self.QMAIL_GID, \
						config.qmail["directory"]["domains"])))
					f.close()

					retval = True

		elif action == "remove" :
			if not domain in self.assign_list.keys() :
				retval = -2
			else :
				cur_list = self.assign_list
				del(cur_list[domain])

				try :
					f = open(config.qmail["file"]["assign"], "w")
				except :
					retval = False
				else :
					if len(cur_list) < 1 :
						f.write(".")
					else :
						f.write("%s\n.\n" % "\n".join(cur_list.values()))

					f.close()

					retval = True
		else :
			retval = False

		if retval :
			self.__update_assign()
			self.__get_assign()

		return retval

	def __update_assign (self) :
		a = os.system(config.qmail["file"]["qmail-newu"])

		if a == 0 :
			retval = True
		else :
			retval = False

		return retval

	#--------------------------------------------------
	def add (self, domain) :
		retval = self.__domain("add", domain);

		return retval

	def remove (self, domain) :
		retval = self.__domain("remove", domain);

		return retval

 	def __domain (self, action, domain) :
 		"""
		* job sequence
			rcpthosts
			virtualdomains
			make directory
			make .qmail-default file
			assign
			execute qmail-newu

		* return value
			True : success
			False : failed

			-4 : login failed
			-3 : it's not valid domain
			-2 : it's already exists
		"""
		self.domain_list = []

		self.rcpthosts_list = {}
		self.virtualdomains_list = {}
		self.assign_list = {}

		if not message.is_valid_domain(domain) : retval = -3

		self.__get_domain_list()

		# check the domain is duplicated or not.
		if action == "add" and not self.__check_domain_in_list(domain) :
			retval = True
		elif action == "remove" and self.__check_domain_in_list(domain) :
			retval = True
		else :
			retval = -2

		if retval == True :

			# rcpthosts
			retval = self.__rcpthosts(action, domain)

			# virtualdomains
			if retval == True :
				retval = self.__virtualdomains(action, domain)
			elif retval == False :
				self.__rcpthosts(self.action[action], domain)

				retval = False

			# assign
			if retval == True :
				retval = self.__assign(action, domain)
			elif retval == False :
				self.__rcpthosts(self.action[action], domain)
				self.__virtualdomains(self.action[action], domain)

				retval = False

 		return retval

	###################################################
	"""
	DB jobs.
	"""

	def do_DB (self, action, domain, **options) :

		if action == "add" :
			retval = self.__add_domain_priv (domain, **options)

			if retval : retval = self.__add_domain_user(domain, **options)

		elif action == "remove" :
			retval = self.__remove_domain_priv (domain)

			# remove postmaster.
			if retval : retval = self.__remove_domain_user(domain)

			# remove all user in domain.
			if retval : retval = self.__remove_user(domain)

		else :
			retval = False

		return retval

	def __add_domain_priv (self, domain, **options) :

		X = myXML.myXML()
		X.set_tables_xml()
		tables = X.get_table_scheme()

		if len(tables) < 1 :
			retval = False
		else :
			id = int(time.time())

			# register domain in domain_priv.
			query = sql.SQL_DOMAIN["add"] % \
				( \
					id, \
					domain, \
					int(options["quota"]) * 1000000, \
					id, \
					int(options["message_size_limit"]) * 1000000, \
					int(options["document_size_limit"]) * 1000000, \
					options["filter"], \
					options["block_address"], \
					options["remote_server"], \
					options["user"], \
					myMySQLdb.escape_string(options["password"]), \
					myMySQLdb.escape_string(options["password"]), \
					myMySQLdb.escape_string(options["www_domain_name"]) \
				)

			self.DB.query(query)
			retval = self.DB.retval

			return retval

	def __add_domain_user (self, domain, **options) :

		U = User.User(self.DB)
		U.set_name("postmaster", domain)

		retval = U.add(**options)

		return retval

	def __remove_domain_user (self, domain) :

		U = User.User(self.DB)
		U.set_name("postmaster", domain)

		retval = U.remove()

		return retval

	def __remove_domain_priv (self, domain) :

		P = Privilege.Privilege(self.DB)

		id = P.get_domain_id(domain)

		# remove in domain_priv
		self.DB.query(sql.SQL_DOMAIN["remove"] % domain)
		retval = self.DB.retval

		# remove in domain_alias_priv
		if retval : self.DB.query(sql.SQL_DOMAIN["remove_in_alias"] % id)

		return retval

	def __remove_user (self, domain) :

		U = User.User(self.DB)
		user_list = U.get_all_user_in_domain(domain)

		for id, name, domain in user_list :
			U.set_name(name, domain)
			U.remove()

		return True

	def status (self) :

		delm = "   - "

		# rcpthosts, virtualdomains, assign
		self.__get_rcpthosts()
		self.__get_virtualdomains()
		self.__get_assign()

		# sort list
		self.rcpthosts_list.keys().sort()
		self.virtualdomains_list.keys().sort()
		self.assign_list.keys().sort()

		l = {}
		# set location of qmail control files
		l["location_rcpthosts"] = config.qmail["file"]["rcpthosts"]
		l["location_virtualdomains"] = config.qmail["file"]["virtualdomains"]
		l["location_assign"] = config.qmail["file"]["assign"]

		l["list_rcpthosts"] = delm + "\n   - ".join(self.rcpthosts_list.keys())
		l["list_virtualdomains"] = delm + "\n   - ".join(self.virtualdomains_list.keys())
		l["list_assign"] = delm + "\n   - ".join(self.assign_list.keys())

		try :
			# domain_priv
			domain_priv = \
				self.DB.query_all("select name, id, valid from domain_priv order by name")
		except :
			l["list_domain_priv"] = delm + "NONE"
		else :
			dlist = list()
			for i in domain_priv :
				dlist.append(i[0])

			l["list_domain_priv"] = delm + "\n   - ".join(dlist)

		retval = l

		return retval


__author__ =  "Spike^ekipS <spike@spikeekips.net>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "Domain.py"

