# -*- coding: utf-8 -*-
import os
import config, sql
import myMySQLdb, message, MailFilter

class Save :

	__db = None

	def __init__ (self, **kwd) :

		self.__db = kwd["db"]

	def close (self) :
		pass

	def save (self) :

		# read file list in config.qmail["directory"]["message"]
		try :
			os.chdir(config.qmail["directory"]["message"])
		except OSError :
			raise OSError, \
				"No such file or directory, %s" % config.qmail["directory"]["message"]
		else :
			for i in os.listdir(".") : # read current directory.

				f_path = "%s/%s" % (config.qmail["directory"]["message"], i)

				if os.path.isdir(f_path) : continue
				if os.path.islink(f_path) : continue

				if os.path.isfile(f_path) :

					a = i.split("-")
					address = str(a[0])

					if a > 1 :
						message_id = a[1]
					else :
						message_id = \
							sha.new("%s.%s" % \
								(int(time.time()), str(random.random()))).hexdigest()

					# check filename is valid or not. If not, remove file.
					if not message.is_valid_address(address) :
						self.remove(f_path)
						continue

					# read message from file
					try :
						msg = "".join(open(f_path, "r").readlines())
					except :
						self.remove(f_path)
						continue

					# apply GLOBAL filter.
					if not self.run_filter(msg) :
						self.remove(f_path)
						continue

					# insert message.
					if not self.insert_message(address, msg, message_id) :
						self.remove(f_path)
						continue

					# remove file.
					self.remove(f_path)

	def remove (self, filename) :
		try :
			os.remove(filename)
		except :
			retval = False
		else :
			retval = True

		return retval

	def run_filter (self, msg) :

		F = MailFilter.Filter(self.__db, "global")
		F.set_message(msg)

		# If message is normal messages, F.apply(..) returns only -2.
		# And only check whether this message was set to remove or not.
		if F.apply() == -1 :
			retval = False
		else :
			retval = True

		return retval

	def insert_message (self, address, msg, message_id) :

		DB = myMySQLdb.myMySQLdb(self.__db)
		DB.start_transaction(True)

		DB.query( \
			sql.SQL_INSERT_QUEUE_INCOMING % \
			(address, myMySQLdb.escape_string(msg) , message_id) \
		)

		retval = DB.retval
		DB.close()

		return retval



__author__ =  "Spike^ekipS <spike@spikeekips.net>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "Save.py"

