<?

include_once $global["root"] . "/lib/Domain.php";
include_once $global["root"] . "/lib/Authentication.php";
include_once $global["root"] . "/lib/MySQLdb.php";
include_once $global["root"] . "/lib/Session.php";
include_once $global["root"] . "/lib/Mail.php";
include_once $global["root"] . "/lib/HTTP_lib.php";
include_once $global["root"] . "/lib/Extend_Quota.php";
include_once $global["root"] . "/lib/Template.php";

class Site {

	var $URL_MAIL = "Location: http://%s/mail.php";
	var $URL_GLOBAL = "Location: http://%s/global.php";
	var $URL_NONE = "Location: http://%s/invalid.php";
	var $URL_LOGIN = "Location: http://%s/login.php";

	var $DB;
	var $Session;
	var $Template;

	var $save_history = true;

	var $users = array("user", "postmaster");

	function Site ($type=false, $httpd_method=false) {

		if ($type) $this->init($type, $httpd_method);

		$this->Template = new Template;

		$this->permission = array();
		$this->permission["user"] = array("user","postmaster","global");
		$this->permission["postmaster"] = array("postmaster");
		$this->permission["global"] = array("global");
	}

	////////////////////////////////////////////////////////////////////////
	function init ($http_method="_POST") {

		// connect DB
		$this->connect_db();

		$this->start_session();

		$this->is_session_alive();

		$this->check_invalid_domain();

		// check security on user.
		$this->__check_authentication($http_method);

		// reg_session
		$this->reg_session();
	}

	function set_permission ($user_type="user") {

		if (! array_key_exists($_SESSION["user_type"], $this->permission)) {
			$this->force_logout();
		}

		if (! in_array($_SESSION["user_type"], $this->permission[$user_type])) {
			$this->force_logout();
		}
	}

	function init1 ($http_method="_POST") {

		// connect DB
		$this->connect_db();

		$this->start_session();

		$this->check_invalid_domain();

		// get the default domain infomation and set the theme directory to use.
		$this->Template->set_theme();

		// reg_session
		$this->reg_session();
	}

	function init2 ($http_method="_POST") {
		// for non-privileged user.
		global $global;

		// connect DB
		$this->connect_db();

		$this->start_session();

		$this->check_invalid_domain();

		// set module type.
		//unset($_SESSION["user_module"]);
		unset($_SESSION["user_authenticated"]);

		// get the default domain infomation and set the theme directory to use.
		$this->Template->set_theme();

		// reg_session
		$this->reg_session();
	}

	// force logout
	function force_logout () {

		@session_destroy();
		$url = sprintf($this->URL_LOGIN, $_SERVER["HTTP_HOST"]);
		Header($url);
		exit;
	}

	// page navigation history.
	function reformat_history () {

		$n = count($_SESSION["user_history_page"]);

		if ($n > 3) {
			$a = $_SESSION["user_history_page"];
			unset($_SESSION["user_history_page"]);

			$_SESSION["user_history_page"][] = $a[$n - 3];
			$_SESSION["user_history_page"][] = $a[$n - 2];
			$_SESSION["user_history_page"][] = $a[$n - 1];
		}
	}

	function check_history () {
		$this->reformat_history();

		$h = new HTTP_lib;
		$url = $_SERVER["REQUEST_URI"];

		if ($_SESSION["user_previous_page"] == $url) {
			$a = $_SESSION["user_history_page"];
			array_pop($a);
			array_pop($_SESSION["user_history_page"]);
			$_SESSION["user_previous_page"] = array_pop($a);

			$this->save_history = false;
		}
	}

	function register_history ($save) {

		$h = new HTTP_lib;
		$url = $h->get_url_except_this("st", $_SERVER["REQUEST_URI"]);

		/*
		if ($this->save_history and ($save and ! $_SESSION["user_not_save_url"])) {
			$_SESSION["user_history_page"][] = $url;
			$_SESSION["user_previous_page"] = $url;
		}
		*/
	}

	function __end ($save=false) {

		$this->register_history($save);

		unset($_SESSION["user_not_save_url"]);

		session_write_close(); // write session

		// close DB connection.
		mysql_query("======================================"); // remove this.
		$this->close_db();
	}

	function end ($save=false) {
		if (array_key_exists("tmp", $_SESSION)) unset($_SESSION["tmp"]);
		$this->__end($save);
	}

	function end1($save=false) {

		$this->__end($save);
	}

	////////////////////////////////////////////////////////////////////////
	function check_invalid_domain () {

		if (! $_SESSION["user_authenticated"]) {
			// check this domain is valid or not.
			$Domain = new Domain;

			switch (true) {
				case ($Domain->get_domain_type($_SERVER["HTTP_HOST"]) !== strval("www")) :
					@session_destroy();
					Header(sprintf($this->URL_NONE, $_SERVER["HTTP_HOST"]));
					exit;
				break;
			}
		}

		return true;
	}

	function set_direction () {

		if (! $_SESSION["user_authenticated"]) {
			session_destroy();
			$this->close_db();
			Header(sprintf($this->URL_LOGIN, $_SERVER["HTTP_HOST"]));
			exit;
		}

		if (in_array($_SESSION["user_type"], $this->users)) {
			Header(sprintf($this->URL_MAIL, $_SERVER["HTTP_HOST"]));
			exit;
		} else if ($_SESSION["user_type"] == "global") {
			Header(sprintf($this->URL_GLOBAL, $_SERVER["HTTP_HOST"]));
			exit;
		}

		// if nothing else, go-out.
		session_destroy();
		$this->close_db();
		Header(sprintf($this->URL_NONE, $_SERVER["HTTP_HOST"]));
		exit;
	}

	////////////////////////////////////////////////////////////////////////
	function __check_authentication($http_method=false) {
		global $global;

		if ($_SESSION) {

			// execute authentication check.
			switch ($_SESSION["user_type"]) {
				case ("user") :
					include_once $global["root"] . "/lib/Authentication_User.php";
					$Auth = new Authentication_User;
				break;
				case ("postmaster") :
					include_once $global["root"] . "/lib/Authentication_User.php";
					$Auth = new Authentication_User;
				break;
				case ("global") :
					include_once $global["root"] . "/lib/Authentication_Global.php";
					$Auth = new Authentication_Global;
				break;

				default :
					$this->force_logout();
			}

			//-------------------------------------------------- check on security
			if ($http_method) $Auth->escape($http_method);

			$Auth->check();
		}

	}

	function connect_db () {
		global $db;

		//-------------------------------------------------- db connection
		$this->DB = new MySQLdb;
		$this->DB->connect($db);

		if ($this->DB->retval) { // mysql connect.
			$this->DB->set_db($db["database"]);

		} else {
			$Auth = new Authentication;
			$Auth->logout();
		}
	}

	function start_session () {

		$this->Session = new Session;
	}

	function is_session_alive () {
		if (! $_SESSION["user_authenticated"]) {
			$this->force_logout();
		}
	}

	function close_db () {

		$DB = new MySQLdb;
		$DB->quit();
	}

	function reg_session () {

		/*
		$_SESSION["user_global_url"] = sprintf("http://%s", $_SERVER["HTTP_HOST"]);
		$_SESSION["user_theme_url"] =
			sprintf("http://%s/template/%s", $_SERVER["HTTP_HOST"], $_SESSION["config_theme"]);
		*/

		// check history
		$this->check_history();

	}

	////////////////////////////////////////////////////////////////////////
	function msg () {
		// msg

		if (! $_SESSION["tmp"]["msg"]["content"]) {
			$retval = false;
		} else {
			$var["content"] = $_SESSION["tmp"]["msg"]["content"];

			// msg_type :
			//	1 : warning
			//	2 : info
			switch ($_SESSION["tmp"]["msg"]["type"]) {
				case ("2") :
					$var["type"] = "msg_info";
					$var["msg"] = $string["error_type"];
				break;
				default :
					$var["type"] = "msg_warning";
					$var["msg"] = $string["error_type1"];
			}

			$retval = $this->Template->generate("global/msg", $var);
		}

		return $retval;
	}
}

/*
Description
-----------

Author
------
 Spike^ekipS <spike@spikeekips.net>

Changelog
---------

Usage
-----

*/

?>
