<?

include_once $global["root"] . "/lib/EmailData.php";
include_once $global["root"] . "/lib/Template.php";
include_once $global["root"] . "/include/print_byte.php";

class Payload {

	var $data_dir;
	var $doc_data_dir;
	var $Template;

	var $total_size;

	function Payload () {
		global $global;

		$this->data_dir = sprintf("%s/message/%s", $global["data"], $_SESSION["config_id"]);
		$this->doc_data_dir =
			sprintf("%s/doc/%s", $global["data"], $_SESSION["config_id"]);

		$this->__check();
		$this->Template = new Template;
	}

	function __check () {
		global $global;

		if (! is_dir($this->data_dir)) {
			$retval = mkdir($this->data_dir);
		} else {
			$retval = true;
		}

		return $retval;
	}

	function get_total_size () {
		if (array_key_exists("user_payload", $_SESSION)) {
			$dh = opendir($this->data_dir);

			while (($file = readdir($dh)) !== false) {

				$ff = $this->data_dir . "/" . $file;

				if (is_dir($ff)) continue;
				if (! is_file($ff)) continue;

				if (! array_key_exists($file, $_SESSION["user_payload"])) {
					$this->remove($file);
					continue;
				}

				$size = filesize($ff);
				$this->total_size += $size;

			}
			closedir($dh);
		}

		if (array_key_exists("user_payload_as_document", $_SESSION)) {
			reset($_SESSION["user_payload_as_document"]);

			while (list($i, $j) = each($_SESSION["user_payload_as_document"])) {
				$ff = $this->doc_data_dir . "/" . $i;

				$size = filesize($ff);
				$this->total_size += $size;
			}
		}

		return $this->total_size;
	}

	function clean () {

		// remove document payload.
		unset($_SESSION["user_payload_as_document"]);

		// remove session value and remove uploaded file.
		if (is_array($_SESSION["user_payload"]) and count($_SESSION["user_payload"]) > 0) {
			reset($_SESSION["user_payload"]);
			while (list($i, $j) = each($_SESSION["user_payload"])) {
				$this->remove($i);
			}

			unset($_SESSION["user_payload"]);
		}

		return true;
	}

	function return_name () {
		/*
		return value is,
			$array[stored name]["name"] = real name
			$array[stored name]["size"] = size
		*/

		$var = array();

		if (array_key_exists("user_payload", $_SESSION)) {
			$dh = opendir($this->data_dir);

			while (($file = readdir($dh)) !== false) {

				$ff = $this->data_dir . "/" . $file;

				if (is_dir($ff)) continue;
				if (! is_file($ff)) continue;

				if (! array_key_exists($file, $_SESSION["user_payload"])) {
					$this->remove($file);
					continue;
				}

				$size = filesize($ff);
				$this->total_size += $size;

				$var[$file]["name"] = $_SESSION["user_payload"][$file]["name"];
				$var[$file]["size"] = $size;
			}
			closedir($dh);
		}

		if (array_key_exists("user_payload_as_document", $_SESSION)) {
			reset($_SESSION["user_payload_as_document"]);

			while (list($i, $j) = each($_SESSION["user_payload_as_document"])) {
				$ff = $this->doc_data_dir . "/" . $i;

				$size = filesize($ff);
				$this->total_size += $size;

				$stored_name = sprintf("doc_%s", $i);

				$var[$stored_name]["name"] = $j["name"];
				$var[$stored_name]["size"] = $size;
			}
		}

		$retval = $var;

		return $retval;
	}

	// $name is real name.
	function check_duplicated ($name) {

		$retval = false;

		if (! array_key_exists("user_payload", $_SESSION)) {
			$retval = false;
		} else {
			while (list($i, $j) = each($_SESSION["user_payload"])) {
				if ($j["name"] == $name) $retval = true;
			}
		}

		return $retval;
	}

	function insert () {
		global $string;

		$retval = true;

		// check file size.
		if (! $_FILES["userfile"]["tmp_name"]) {
			$retval = false;
			$_SESSION["tmp"]["msg"]["content"] = $string["error6"];
		}

		if ($retval and $_FILES["userfile"]["size"] < 1) {
			$retval = false;
			$_SESSION["tmp"]["msg"]["content"] = $string["error7"];
		}

		// calculate total size of inserted payloads.
		$this->get_total_size();

		if ($retval and ($this->total_size + $_FILES["userfile"]["size"] >
				$_SESSION["config_message_size_limit"])) {
			$retval = false;

			$_SESSION["tmp"]["msg"]["content"] =
				sprintf(
					$string["error8"],
					print_byte(intval($_SESSION["config_message_size_limit"]))
				);
		}

		if ($retval and $this->check_duplicated($_FILES["userfile"]["name"])) {
			$retval = false;
			$_SESSION["tmp"]["msg"]["content"] =
				sprintf($string["error1"], $_FILES["userfile"]["name"]);
		}

		if ($retval) {

			$file_id = mktime().mt_rand(0,20);

			$storedFilename = $this->data_dir . "/" . $file_id;

			if (move_uploaded_file($_FILES["userfile"]["tmp_name"], $storedFilename)) {
				$retval = true;
			} else {
				$retval = false;
				$_SESSION["tmp"]["msg"]["content"] = $string["error2"];
			}
		}

		if ($retval) {
			$_SESSION["user_payload"][$file_id]["name"] = $_FILES["userfile"]["name"];
			$_SESSION["user_payload"][$file_id]["type"] = $_FILES["userfile"]["type"];
		}

		return $retval;
	}

	function remove ($name) {

		if (ereg("^doc_", $name)) { // remove document payload
			unset($_SESSION["user_payload_as_document"][ereg_replace("^doc_", "", $name)]);
			$retval = true;
		} else {
			if (! file_exists($this->data_dir . "/" . $name)) {
				$retval = false;
			} else {
				unlink($this->data_dir . "/" . $name);
				$retval = true;
			}

			unset($_SESSION["user_payload"][$name]);
		}

		return $retval;
	}

	function return_form () {
		global $global, $string;

		// find already inserted payload.
		$ret = $this->return_name();

		if (count($ret) < 5) {
			$var["inserted_payload_num"] = 5;
		} else {
			$var["inserted_payload_num"] = count($ret) + 1;
		}

		if (count($ret) > 0) {
			$var["inserted_payload"] =
				sprintf("<option value=\"\" disabled>%s\n", $string["message128"]);

			while (list($i, $j) = each($ret)) {
				$var["inserted_payload"] .=
					sprintf("<option onClick=\"viewPayload('payload','%s');\"
						value=\"%s\">%s (%s)\n",
						$j["name"], $i, $j["name"], print_byte($j["size"])
					);
			}
		} else {
			$var["inserted_payload"] =
				sprintf("<option value=\"\" disabled>%s\n", $string["message13"]);
		}

		$var["total_size"] = print_byte($this->total_size);
		$retval =
			$this->Template->generate("message/add_payload", $var);

		return $retval;
	}

	function message_form ($boundary) {

		$msg = array();

		$EmailData = new EmailData;

		// document payload
		if (array_key_exists("user_payload_as_document", $_SESSION) and
				is_array($_SESSION["user_payload_as_document"])) {
			reset($_SESSION["user_payload_as_document"]);

			while (list($i, $j) = each($_SESSION["user_payload_as_document"])) {
				$f = implode("", file($this->doc_data_dir . "/" . $i));
				$data = preg_replace("/\n$/", "", $EmailData->encode($f));
				unset($f);

				$p["payloadBody"] = $data;

				$p["type"] = $j["type"];
				$p["filename"] = $j["name"];
				$p["boundary"] = $boundary;

				$msg[] = $this->Template->generate("message/messagePayload", $p);

				unset($data);
				unset($p);
			}
		}

		// uploaded payload.
		if (array_key_exists("user_payload", $_SESSION) and
				is_array($_SESSION["user_payload"])) {

			reset($_SESSION["user_payload"]);

			while (list($i, $j) = each($_SESSION["user_payload"])) {
				$f = implode("", file($this->data_dir . "/" . $i));
				$data = preg_replace("/\n$/", "", $EmailData->encode($f));
				unset($f);

				$p["payloadBody"] = $data;

				$p["type"] = $j["type"];
				$p["filename"] = $j["name"];
				$p["boundary"] = $boundary;

				$msg[] = $this->Template->generate("message/messagePayload", $p);

				unset($data);
				unset($p);
			}
		}

		if (count($msg) < 1) {
			$retval = "";
		} else {
			$retval = implode("\n", $msg);
		}

		return $retval;
	}

	function save ($data) {
		global $global;

		$save_dir = sprintf("%s/payload/%s", $global["data"], $_SESSION["config_id"]);

		if (! is_dir($save_dir)) { // check whether directory exists or not.
			if (! mkdir($save_dir)) { // create directory.
				$retval = false;
			}
		} else {
			if (! is_writable($save_dir)) {
				$retval = false;
			} else {
				// make random file name.
				$file_id = sprintf("%s.%s", mktime(), rand());
				$file_path = sprintf("%s/%s", $save_dir, $file_id);

				// save data as random file name.
				$fh = fopen($file_path, "w");
				fwrite($fh, $data);
				fclose($fh);

				$retval = $file_id;
			}
		}

		return $retval;
	}
}


/*
Description
-----------

Author
------
 Spike^ekipS <spike@spikeekips.net>

Changelog
---------

Usage
-----

*/

?>
